Ошибка памяти при использовании pip install Matplotlib

Я использую Python 2.7, если я пытаюсь установить Matplotlib, я получаю эту ошибку, если я использую «pip install matplotlib»,

Exception: Traceback (most recent call last): File "/usr/local/lib/python2.7/dist-packages/pip/basecommand.py", line 232, in main status = self.run(options, args) File "/usr/local/lib/python2.7/dist-packages/pip/commands/install.py", line 339, in run requirement_set.prepare_files(finder) File "/usr/local/lib/python2.7/dist-packages/pip/req/req_set.py", line 355, in prepare_files do_download, session=self.session, File "/usr/local/lib/python2.7/dist-packages/pip/download.py", line 782, in unpack_url session, File "/usr/local/lib/python2.7/dist-packages/pip/download.py", line 667, in unpack_http_url from_path, content_type = _download_http_url(link, session, temp_dir) File "/usr/local/lib/python2.7/dist-packages/pip/download.py", line 843, in _download_http_url _download_url(resp, link, content_file) File "/usr/local/lib/python2.7/dist-packages/pip/download.py", line 615, in _download_url for chunk in progress_indicator(resp_read(4096), 4096): File "/usr/local/lib/python2.7/dist-packages/pip/utils/ui.py", line 46, in iter for x in it: File "/usr/local/lib/python2.7/dist-packages/pip/download.py", line 580, in resp_read decode_content=False): File "/usr/local/lib/python2.7/dist-packages/pip/_vendor/requests/packages/urllib3/response.py", line 256, in stream data = self.read(amt=amt, decode_content=decode_content) File "/usr/local/lib/python2.7/dist-packages/pip/_vendor/requests/packages/urllib3/response.py", line 186, in read data = self._fp.read(amt) File "/usr/local/lib/python2.7/dist-packages/pip/_vendor/cachecontrol/filewrapper.py", line 54, in read self.__callback(self.__buf.getvalue()) File "/usr/local/lib/python2.7/dist-packages/pip/_vendor/cachecontrol/controller.py", line 205, in cache_response self.serializer.dumps(request, response, body=body), File "/usr/local/lib/python2.7/dist-packages/pip/_vendor/cachecontrol/serialize.py", line 81, in dumps ).encode("utf8"), MemoryError" 

В чем проблема? Я использую малину Pi 2 с 16-гигабайтной SD-картой. У меня все еще есть 8 гб данных, но все еще получаю эту ошибку. Просьба помочь

Эта ошибка возникает, потому что, кажется, механизм кэширования ПП пытается прочитать весь файл в памяти до его кеширования … что создает проблему в среде с ограниченной памятью, поскольку matplotlib составляет ~ 50 МБ.

Более простое решение, до тех пор, пока pip не будет исправлен, чтобы использовать алгоритм кэширования с постоянным пространством, заключается в том, чтобы запустить pip с --no-cache-dir чтобы избежать кеша:

 $ pip --no-cache-dir install matplotlib 

Кажется, у вас недостаточно памяти для создания matplotlib с нуля. Чтобы преодолеть это, включите своп:

 # create swap file of 512 MB dd if=/dev/zero of=/swapfile bs=1024 count=524288 # modify permissions chown root:root /swapfile chmod 0600 /swapfile # setup swap area mkswap /swapfile # turn swap on swapon /swapfile 

Или, если у вас установлен raspbian на вашей SD-карте, вы можете установить matplotlib из репозитория:

 apt-get install python-matplotlib